<?

// on se donne + de temps et + d'espace
$old=ini_set("max_execution_time",1000);
$old2=ini_set("memory_limit",'64M');

/*===========================================================================================

                       extraire les données du fichier XML de STS-WEB

===========================================================================================*/

include_once "./inc/constantes.php";

// nombre minimum de champs pour l'extraction
//$min=5;
// nombre d'entrées valides
$valide=0;
$enseigne=array();
$profmat=array();

// fichier de sortie
$file_out=$f_prof;
if ($cours_gep==1) $mode="w+";
else $mode="a";
if (!$file_sortie = fopen ($file_out, $mode)) {
   echo "Impossible d'ouvrir le fichier de sortie $file_out";
   exit;
}

// fichier pour Gepi
if (!$gepi_file = fopen ("./tmp/prof_disc_classes.tmp", $mode)) {
   echo "Impossible d'ouvrir le fichier prof_disc_classes.tmp";
   exit;
}

// fichier uploadé
`/usr/share/ead/convert.py $professeurs`;
if (!$handle = fopen("$professeurs", "r")) {
   echo " impossible d'ouvrir le fichier professeur $professeurs\n" ;
   exit;
}
fclose($handle);
$doc_xml = xmldocfile($professeurs);

// <STS_EDT>
$root = domxml_children($doc_xml);
if ($root[0]->tagname != "STS_EDT") {
   echo "Le fichier n'est pas un fichier XML de STS-WEB valide";
   exit;
}

$sts_parent = domxml_children($root[0]);
foreach ($sts_parent as $sts){
   ## 1er NIVEAU : NOMENCLATURES
   if (is_tag($sts, "NOMENCLATURES")) {
      $codmatiere = array();
      $nomenclatures_parent = domxml_children($sts);
      foreach($nomenclatures_parent as $nomenclatures) {
         if (is_tag($nomenclatures, "MATIERES")) {
	    $matieres_parent = domxml_children($nomenclatures);
	    foreach($matieres_parent as $matieres) {
	       if (is_tag($matieres, "MATIERE")) {
	          // nomenclature des matieres
	          $codmat = get_attr($matieres, "CODE");
		  $codmatiere[$codmat] = get_content($matieres, "CODE_GESTION");
	       }
	    }
	 }
      }
      if ($codmatiere == array()) {
         print "<font color=red>Aucune matière n'a été définie !</font><br>";
      }
   }
   
   ## 1er NIVEAU : DONNEES
   if (is_tag($sts, "DONNEES")) {
      $donnees_parent = domxml_children($sts);
      ## 2e NIVEAU : STRUCTURE
      foreach($donnees_parent as $donnees) {
         if (is_tag($donnees, "STRUCTURE")) {
	    $structure_parent = domxml_children($donnees);
	    foreach($structure_parent as $structure) {
	       ## STRUCTURE/DIVISIONS
	       if (is_tag($structure, "DIVISIONS")) {
	          $divisions_parent = domxml_children($structure);
		  foreach ($divisions_parent as $divisions) {
		     if (is_tag($divisions,"DIVISION")) {
		        // nom de la classe
			$classe = get_attr($divisions, "CODE");
			$classe = ok_groupe($classe, 'c');
			if (array_key_exists($classe,$renommage)) $classe=$renommage[$classe];
			// fin classe
			$division_parent = domxml_children($divisions);
			foreach ($division_parent as $division) {
			   if (is_tag($division, "SERVICES")) {
			      $services_parent = domxml_children($division);
			      foreach ($services_parent as $services) {
			         if (is_tag($services, "SERVICE")) {
				    // code de la matiere -> nom
				    $type_cours = get_attr($services, "CODE_MOD_COURS");
				    $matiere = get_attr($services, "CODE_MATIERE");				    
				    $matiere = ok_groupe($codmatiere[$matiere], 'm');
				    // fin matiere
				    $service_parent = domxml_children($services);
				    foreach ($service_parent as $service) {
				       if (is_tag($service, "ENSEIGNANTS")) {
				          $enseignants_parent = domxml_children($service);
					  foreach ($enseignants_parent as $enseignants) {
					     if (is_tag($enseignants, "ENSEIGNANT")) {
					        // enseignant
						$ens = get_attr($enseignants, "ID");
						if (array_key_exists($ens, $enseigne)) {
						   $enseigne[$ens].="$classe ";
						   $profmat[$ens].="$matiere ";
						}else{
						   $enseigne[$ens]="$classe ";
						   $profmat[$ens]="$matiere ";
						}
						if ($type_cours == 'CG') {
						   fwrite($gepi_file,"$ens#".strtolower("$matiere;$classe;").
						                     "$type_cours\n");
						}
						// fin enseignant
				             }
					  }
				       }
				    }
				 }
		              }
			   }
			}
	             }// fin DIVISION
		  }
	       ## STRUCTURES/GROUPES
	       } elseif (is_tag($structure, "GROUPES")) {
	          $groupes_parent = domxml_children($structure);
		  foreach ($groupes_parent as $groupes) {
		     if (is_tag($groupes, "GROUPE")) {
		        // nom du groupe
			//get_attr($groupes, "CODE");
			$groupe_classes = array();
			// fin groupe
			$groupe_parent = domxml_children($groupes);
			foreach ($groupe_parent as $groupe) {
			   if (is_tag($groupe, "DIVISIONS_APPARTENANCE")) {
			      $divisions_parent = domxml_children($groupe);
			      foreach ($divisions_parent as $divisions) {
			         if (is_tag($divisions, "DIVISION_APPARTENANCE")) {
				    // récupération des classes concernées
				    $classe = ok_groupe(get_attr($divisions, "CODE"), 'c');
			            if (array_key_exists($classe,$renommage)) $classe=$renommage[$classe];
				    $groupe_classes[] = $classe;
				 }
			      }
			       
			   } elseif (is_tag($groupe, "SERVICES")) {
			      $services_parent = domxml_children($groupe);
			      foreach ($services_parent as $services) {
			         $matiere = "";
			         if (is_tag($services, "SERVICE")) {
				    $cod_mat = get_attr($services, "CODE_MATIERE");
				    $matiere = ok_groupe($codmatiere[$cod_mat], 'm');
				    //print get_attr($services, "CODE_MOD_COURS");
				    $service_parent = domxml_children($services);
				    foreach ($service_parent as $service) {
				       if (is_tag($service, "ENSEIGNANTS")) {
				          $enseignants_parent = domxml_children($service);
					  foreach ($enseignants_parent as $enseignants) {
					     if (is_tag($enseignants, "ENSEIGNANT")) {
					        foreach ($groupe_classes as $classe) {
					           $ens = get_attr($enseignants, "ID");
                                                   if (array_key_exists($ens, $enseigne)) {
						      $enseigne[$ens].="$classe ";
						      $profmat[$ens].="$matiere ";
						   }else{
						      $enseigne[$ens]="$classe ";
						      $profmat[$ens]="$matiere ";
						   }
						   fwrite($gepi_file,"$ens#".strtolower("$matiere;$classe;")."OPT\n");
						}
						
					     }    
					  }
				       }
				    }
				 }
			      }

			   }
			}
		     }
	          }

	       }
            }
	 }
      }
      if ($enseigne == array()) {
         print "<font color=red>Les équipes pédagogiques n'ont pas été renseignées dans STS !</font><br>";
      }	 

      ## 2e NIVEAU : INDIVIDUS
      foreach($donnees_parent as $donnees) {
         if (is_tag($donnees, "INDIVIDUS")) {
	    $individus_parent = domxml_children($donnees);
	    foreach ($individus_parent as $individus) {
	       if (is_tag($individus, "INDIVIDU")) {
	       // UN PROFESSEUR
	          unset($tab);
		  unset($id);
		  $princ = 0;
		  $disc = "";
	          $attrs = domxml_attributes($individus);
		  foreach ($attrs as $attr) {
		     if ($attr->name == "ID") {
		        $id = $attr->value;
			break;
	             }
		  }
	          $individu_parent = domxml_children($individus);
		  foreach ($individu_parent as $individu) {
                     if ($individu->type == 3) continue;
		     # balise prof principal
    	             if ($individu->tagname == "PROFS_PRINC"){
    		        $profs_princ_parent = domxml_children($individu);
    		        foreach ($profs_princ_parent as $profs_princ) {
    		           if (is_tag($profs_princ, "PROF_PRINC")) {
    		              $princ = get_content($profs_princ, "CODE_STRUCTURE");
    			      $princ = ok_groupe($princ, 'c');
    		           }
    		        }		  			   
    		     }
    		     # balise discipline FIXME : utilisée
    	             elseif ($individu->tagname == "DISCIPLINES"){
    		        $disciplines_parent = domxml_children($individu);
    		        foreach ($disciplines_parent as $disciplines) {
    		           if (is_tag($disciplines, "DISCIPLINE")) {
    		              $discipline = get_content($disciplines, "LIBELLE_COURT");
    			      $disc .= ok_groupe($discipline, 'm').' ';
    		           }
    		        }
                     }
    		     # autres balises (nom, prénom...)
    		     else {
    		        $value = domxml_children($individu);
    		        $tab[$individu->tagname]=$value[0]->content;
    		     }
		  }
		  if (!array_key_exists($id, $profmat)) $profmat[$id]="";
		  if (!array_key_exists($id, $enseigne)) $enseigne[$id]="";
		  $buffer = $tab["NOM_USAGE"].":".$tab["PRENOM"].":".$tab["SEXE"].":".$id.":".$princ.":";
		  $buffer.= ereg_replace('-','',$tab["DATE_NAISSANCE"]).":".$profmat[$id].":".$enseigne[$id].":".$disc."\n";
                  fwrite ($file_sortie, $buffer);
                  $valide++;
                  if (fmod($valide,100)==0) {
                     if ($valide!=0) {
                        print "<font size=-1>$valide professeurs lus</font><br>";
                        flush();
                     } 
                  }
	       } // FIN PROFESSEUR  
	    }
	 }
      }
   }
}
// fermeture de tous les fichiers
fclose ($file_sortie);
fclose ($gepi_file);
echo "<h3>".$valide." professeurs ont été extraits</h3>";

?>
