<?

// on se donne + de temps que d'habitude
$old=ini_set("max_execution_time",1000);

/*===========================================================================================

                       extraire les données d'un fichier CSV

===========================================================================================*/

include_once "./inc/constantes.php";

// nombre minimum de champs pour l'extraction
$min=7;
// nombre d'entrées valides
$valide=0;

// fichier de sortie
$file_out=$f_eleve;
if (!$file_sortie = fopen ($file_out, "w+")) {
   echo "Impossible d'ouvrir le fichier de sortie $file_out";
   exit;
}
// fichier uploadé
$row = 1;
`/usr/share/ead/convert.py $eleves`;
if (!$handle = fopen("$eleves", "r")) {
   echo " impossible d'ouvrir le fichier eleve $$eleves\n" ;
   exit;
}
while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) {
   if ($num = count($data) < $min) {
       echo "ligne ".$data[0]." invalide<br>\n";
   }else{
   
   // définition du fichier :
   // 0. numéro élève
   // 1. nom
   // 2. prénom
   // 3. sexe
   // 4. date de naissance
   // 5. niveau
   // 6. classe
   // (7) login forcé
   // (8) mot de passe forcé
      
   // numéro élève
   if ( ! ($record["ELENOET"]=trim($data[0])) ) {
      $record["ELENOET"] = 'text';
   }
   // nom
   $record["ELENOM"] = replace_car(ereg_replace('[ ]+'," ",$data[1])) ;
   $record["ELENOM"] = strtoupper(trim($record["ELENOM"])) ;
   // prénom
   $record["ELEPRE"] = replace_car(ereg_replace('[ ]+'," ",$data[2])) ;
   $record["ELEPRE"] = trim($record["ELEPRE"]) ;
   // sexe
   $record["ELESEXE"] = ereg_replace('[ ]+',"",$data[3]) ;
   if ($record["ELESEXE"]) {
      // pour l'annuaire ldap la civilité doit etre numerique par consequent on remplace
      // les lettre par le chiffres correspondant 
      $record["ELESEXE"] = ereg_replace("M","1",$record["ELESEXE"]) ;
      $record["ELESEXE"] = ereg_replace("F","3",$record["ELESEXE"]) ;
   } else $record["ELESEXE"] = "0";
   // date de naissance
   $record["ELEDATENAISS"] = ereg_replace('[ ]+',"",$data[4]);
   $record["ELEDATENAISS"] = ereg_replace('/',"",$record["ELEDATENAISS"]);
   $record["ELEDATENAISS"] = reverse_date2($record["ELEDATENAISS"]);
   // niveau
   $record["MEFLCF"] = ok_groupe($data[5], 'n');
   // classe
   $record["DIVCOD"] = ok_groupe($data[6], 'c');

   /* champs facultatifs */
   $record["LOGIN"] = ereg_replace('[ ]+',"",$data[7]) ;
   $record["MDP"] = ereg_replace('[ ]+',"",$data[8]) ;
 
   if ($record["DIVCOD"]!="") {
      // cas ou la classe a le même nom que le niveau
      if ($record["DIVCOD"]==$record["MEFLCF"]) {
         $modif_classe=$record["DIVCOD"]."1";      
         $renommage[$record["DIVCOD"]]=$modif_classe;
         $record["DIVCOD"]=$modif_classe;
      }
      $addr_eleve = "adresse non communiquee";      
      //écriture des données dans un fichier plat
      $buffer =  "$record[ELENOET]:$record[ELENOM]:$record[ELEPRE]:$record[ELESEXE]:".
                 "$record[ELEDATENAISS]:$record[MEFLCF]:$record[DIVCOD]:$addr_eleve:".
		 "$record[LOGIN]:$record[MDP]\n";
		 
      fwrite ($file_sortie, $buffer);
      $valide++;
      if (fmod($valide,100)==0) {
         if ($valide!=0) {
            print "<font size=-1>$valide élèves lus</font><br>";
            flush();
         }
      }
   }
   } // fin entrée invalide
		
} // fin while


// fermeture de tous les fichiers
fclose ($file_sortie);
fclose ($handle);

if (is_array($renommage)) {
   foreach ($renommage as $old => $new) {
      print "<br><font color=green>La classe <b>$old</b> a été renommée en <b>$new</b></font>";
   }
}

echo "<h3>".$valide." élèves ont été extraits</h3>";

// remet l'ancienne valeur !
ini_set("max_execution_time",$old);

?>
