<?

// on se donne + de temps que d'habitude
$old=ini_set("max_execution_time",1000);

/*===========================================================================================

                                   extraire les données des fichiers dbf

=============================================================================================*/

/*test pour la saisies des arguments
if (count($argv) < 5 )
{
   echo "syntaxe: php -q extraire-dbf nom-du-fichier-prof.dbf nom-du-fichier-division.dbf nom-du-fichier-modules.dbf nom-fichier-sortie  \n" ;
   exit;
} 

$dbase     = $argv[1]; // fichier profs
$dbase_div = $argv[2]; // fichier profs ppaux
$dbase_men = $argv[3]; // fichier modules d'enseignement
$file_out  = $argv[4]; // fichier en sortie
*/

// remplacement des para de la ligne de comm par les initialisations
include_once "./inc/constantes.php";
$file_out=$f_prof;
$dbase=$professeurs;
$dbase_div=$divisions;
$dbase_men =$modules;

//* TEST des FICHIERS *//

//initialisation du fichier de sortie
if ($cours_gep==1) $mode="w+";
else $mode="a";
if (!$file_sortie = fopen ($file_out, $mode)) {
   echo "Impossible d'ouvrir le fichier de sortie $file_out";
   exit;
}

if ( !$fp = dbase_open( $dbase, 0)) {
   echo " impossible d'ouvrir la base professeurs $dbase\n" ;exit;
} 
//ouverture du fichier dbf divisions
if ( !$fp_div = dbase_open( $dbase_div, 0)) {
   echo " impossible d'ouvrir la base div $dbase_div\n" ;exit;
}
//ouverture du fichier dbf matières
if ( !$fp_men = dbase_open( $dbase_men, 0)) {
   echo " impossible d'ouvrir la base MEN $dbase_men\n" ;exit;
}

  
// TRAITEMENT PRINCIPAL : professeurs
      
//compte le nb d'enregistrement dans le fichier dbf
$nb_record = dbase_numrecords($fp ) ;
$valide=0 ;
      
for ($cpt =1 ; $cpt <= $nb_record ; $cpt++)
{
 	if (!$record = dbase_get_record_with_names($fp, $cpt)) {
	   echo "Fichier DBF invalide";
	   exit;
        }
	
	// nom du professeur
	$record["AINOMU"] = ereg_replace('[ ]+'," ",$record["AINOMU"]) ;
	$record["AINOMU"] = ereg_replace('\*', '', $record["AINOMU"]) ;
	$record["AINOMU"] = trim($record["AINOMU"]) ;

	// prénom du professeur
	$record["AIPREN"] = ereg_replace('[ ]+'," ",$record["AIPREN"]) ;
	$record["AIPREN"] = ereg_replace('\*', '', $record["AIPREN"]) ;
	$record["AIPREN"] = trim($record["AIPREN"]) ;

	// date de naissance 
	$record["AINADD"] = ereg_replace('[ ]+',"",$record["AINADD"]) ;
	
	// sexe
        $record["AISEXE"] = ereg_replace('[ ]+',"",$record["AISEXE"]) ;
        if ($record["AISEXE"] == '') {
           $record["AISEXE"] = "1";
        }
        
	// numéro du professeur
	$num_prof_dbf=$record["NUMIND"];// besoin de l'original pour le divcod
	$num_prof = ereg_replace('[ ]+',"",$num_prof_dbf) ;
	
	// recuperation de la classe si prof ppal
	$div = recup_div($fp_div, $num_prof_dbf); 
	if ($div) $div = ok_groupe($div, 'c');
	
	// recuperation des classes et des matière associées au prof (sous-séparateur ",")
	$reste = recup_info($fp_men, $num_prof_dbf);
	
	// ecriture des données dans un fichier plat
	// pour l'instant SEULs les profis ppaux ($div != 0)
        if ($record["AINOMU"]!="") //&& ($div != 0))
        {
	     $buffer = "$record[AINOMU]:$record[AIPREN]:$record[AISEXE]:$num_prof:$div:$record[AINADD]:$reste\n" ;
	     fwrite ($file_sortie, $buffer);
	     $valide++;
        } 
	// nouvelle politique de masquage des erreurs
	//else {
	//   $error.="$num_prof ";
	//   $cpt_dead++;
	//}
	if (fmod($valide,100)==0) {
	   if ($valide!=0) {
	      print "<font size=-1>$valide professeurs lus</font><br>";
	      flush();
	   }
	}
}// end for

// fermeture de tous les fichiers
fclose ($file_sortie);
dbase_close($fp_men) ;
dbase_close($fp_div) ;
dbase_close($fp) ;

// nouvelle politique de masquage des erreurs
//echo "<h3>".($nb_record-$cpt_dead)." professeurs valides extraits sur $nb_record</h3>";
//if ($error) echo "<font color=red>Erreur GEP : professeurs invalides <br>
//ATTENTION les professeurs suivants seront ignorés par la suite</font><br>[$error]<br><br>";
echo "<h3>".$valide." professeurs ont été extraits</h3>";

function recup_div ( $fp_div, $num_prof )
{
      //compte le nb d'enregistrement dans le ficheir dbf
      $nb_record_div = dbase_numrecords($fp_div ) ;
      // echo "$nb_record_resp \n";
     
      $cpt_div = 0;
      $div = "0";
      while ( $record_div["NUMIND"] != $num_prof && $cpt_div<$nb_record_div)
      {
	  if (!$record_div = dbase_get_record_with_names($fp_div, $cpt_div )) {
	     echo "Fichier DBF invalide";
	     exit;
          }

	  $cpt_div++;
	  
	  if ( $record_div["NUMIND"] == $num_prof )
	  {
	    $div = $record_div["DIVCOD"];
	  }
      }
      return $div;
}


function recup_info ( $fp, $num_prof )
{
      //compte le nb d'enregistrement dans le ficheir dbf
      $nb_record = dbase_numrecords($fp) ;
      $cpt = 0;
      $equipes="";
      $matieres="";
      $equipes="";
      $t_mat=array();
      $t_dis=array();
      $t_eq =array();
      while ($cpt<$nb_record)
      {
	  if (!$record = dbase_get_record_with_names($fp, $cpt)) {
	     echo "Fichier DBF invalide";
	     exit;
          }

	  $cpt++;
	  
	  if ( $record["NUMIND"] == $num_prof )
	  {
	    // Gestion des doublons
	    $matiere=trim($record["MATIMN"]);
	    $discipline=trim($record["DISCCO"]);
	    $equipe=ereg_replace('[ ]+',"",trim($record["ELSTCO"]));
	    if (!in_array ($matiere,$t_mat)) $t_mat[] = $matiere;
	    if (!in_array ($discipline,$t_dis)) $t_dis[] = $discipline;
	    if (!in_array ($equipe,$t_eq)) $t_eq[] = $equipe;
	  }
      }
      foreach($t_mat as $mat) $matieres.=$mat." ";
      foreach($t_dis as $dis) $disciplines.=$dis." ";
      foreach($t_eq  as $eq ) $equipes.=$eq." ";
      $matieres  = ereg_replace('[ ]$',"",$matieres) ;
      $discipines= ereg_replace('[ ]$',"",$disciplines) ;
      $equipes   = ereg_replace('[ ]$',"",$equipes) ;
      $equipes   = ereg_replace('\*',"e",$equipes) ;
      return ("$matieres:$equipes:$disciplines");
}

// remet l'ancienne valeur !
ini_set("max_execution_time",$old);

?>
