<?

// on se donne + de temps que d'habitude
$old=ini_set("max_execution_time",1000);

/*===========================================================================================

                       extraire les données d'un fichier CSV

===========================================================================================*/

include_once "./inc/constantes.php";

// nombre d'entrées valides
$valide=0;

// gestion des homonymies classes/niveau
if (!isset($renommage)) {
   $renommage = array();
}
$classes = array();
$niveaux = array();

// fichier de sortie si 2eme fichier CSV : concaténation !
$file_out=$f_eleve;
if ($cours_gep==1) $mode="w+";
else $mode="a";
if (!$file_sortie = fopen ($file_out, $mode)) {
   echo "Impossible d'ouvrir le fichier de sortie $file_out";
   exit;
}

// fichier pour Gepi
if (!$gepi_file = fopen ('./tmp/eleves_options.tmp', $mode)) {
   echo "Impossible d'ouvrir le fichier de sortie eleves_options.tmp";
   exit;
}
      

// fichier uploadé
$row = 1;
`/usr/share/ead/convert.py $eleves`;
if (!$handle = fopen("$eleves", "r")) {
   echo " impossible d'ouvrir le fichier eleve $$eleves\n" ;
   exit;
}

// # gestion des attributs OBLIGATOIRES #
$attrs = array("Nom","Prénom 1","Date de naissance","Sexe","MEF","N° Interne","Division");
// nombre minimum de champs pour l'extraction
$min = count($attrs);
// traitement de la première ligne (en-tête)
$data = fgetcsv($handle, 1000, ";");
foreach ($attrs as $attr) {
   if (($index[$attr]=array_search($attr,$data)) === FALSE) {
      print "Le champ $attr est requis !";
      exit;
   }
}

// # gestion adresse 1er responsable #
$adresse_attr = array('Prénom resp.','Nom resp.','Ligne 1 Adresse','Ligne 2 Adresse',
                      'Ligne 3 Adresse','Ligne 4 Adresse',
                      'Code postal resp.', 'Commune resp.');

foreach ($adresse_attr as $attr) {
   if (($index["$attr"]=array_search("$attr",$data)) === FALSE) {
      $index["$attr"] = '-1';
   }
}

// # gestion des Options #
foreach (array('1','2','3','4','5') as $i) {
   if (($index["Option $i"]=array_search("Option $i",$data)) === FALSE) {
      $index["Option $i"] = '-1';
   }
}

$done = array();

// traitement des lignes suivantes...
while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) {
   if (count($data) < $min) {
      if (array_key_exists($index["N° Interne"], $data)) {
         echo "ligne ".$data[$index["N° Interne"]]." invalide<br>\n";
      }
   }else{

      // compatibilité GEP/Sconet
      $numero = trim($data[$index["N° Interne"]]);
      if (!$numero) continue;
      $numero = substr($numero,0,5);
      if (strlen($numero) == 4) {
         $numero = '0'.$numero;
      }
      if (in_array($numero.'#'.$data[$index["Date de naissance"]], $done)) {
         // élève déjà traité
         continue;
      }
      $done[] = $numero.'#'.$data[$index["Date de naissance"]];
      // numéro élève
      $record["ELENOET"] = $numero;
      // nom
      $record["ELENOM"] = replace_car(ereg_replace('[ ]+'," ",$data[$index["Nom"]])) ;
      $record["ELENOM"] = strtoupper(trim($record["ELENOM"])) ;
      if ($record["ELENOM"] == "") continue;
      // prénom
      $record["ELEPRE"] = replace_car(ereg_replace('[ ]+'," ",$data[$index["Prénom 1"]])) ;
      $record["ELEPRE"] = trim($record["ELEPRE"]) ;
      // sexe
      $record["ELESEXE"] = ereg_replace('[ ]+',"",$data[$index["Sexe"]]) ;
      if ($record["ELESEXE"]) {
         // pour l'annuaire ldap la civilité doit etre numerique par consequent on remplace
         // les lettre par le chiffres correspondant 
         $record["ELESEXE"] = ereg_replace("M","1",$record["ELESEXE"]) ;
         $record["ELESEXE"] = ereg_replace("F","3",$record["ELESEXE"]) ;
      } else $record["ELESEXE"] = "1";
      // date de naissance
      $record["ELEDATENAISS"]=ereg_replace('[ ]+',"",$data[$index["Date de naissance"]]);
      $record["ELEDATENAISS"]=ereg_replace('/',"",$record["ELEDATENAISS"]);
      $record["ELEDATENAISS"] = reverse_date2($record["ELEDATENAISS"]);
      $record["ELEDATENAISS"] = ereg_replace('[ ]+',"",$record["ELEDATENAISS"]);
      // niveau
      $record["MEFLCF"] = ok_groupe($data[$index["MEF"]], 'n');
      // classe
      $record["DIVCOD"] = ok_groupe($data[$index["Division"]], 'c');
   
      // adresse :
      $adresse = "";
      foreach ($adresse_attr as $attr) {
         if ($index["$attr"] != -1) {
            if ($data[$index["$attr"]]) {
	       $adresse.=$data[$index["$attr"]].' ';
	    }
	 }
      }
      if (!$adresse) {
         $adresse = "adresse non communiquee";
      }
    
      if ($record["DIVCOD"] != "" and $record["MEFLCF"] != "") {
         if (!in_array($record["DIVCOD"],$classes)) $classes[] = $record["DIVCOD"];
         if (!in_array($record["MEFLCF"],$niveaux)) $niveaux[] = $record["MEFLCF"];
         //écriture des données dans un fichier plat
         $buffer =  "$record[ELENOET]:$record[ELENOM]:$record[ELEPRE]:$record[ELESEXE]:".
                    "$record[ELEDATENAISS]:$record[MEFLCF]:$record[DIVCOD]:$adresse::\n";   		 
         fwrite ($file_sortie, $buffer);

         // traitement pour Gepi
         foreach (array('1','2','3','4','5') as $i) {
	    if ($index["Option $i"] != -1) {
               if ($opt = $data[$index["Option $i"]]) {
     	          fwrite($gepi_file, $record['ELENOET'].'#'.strtolower($opt)."\n");
      	       }
	    }
	 }
         $valide++;
         if (fmod($valide,100)==0) {
            if ($valide!=0) {
               print "<font size=-1>$valide élèves lus</font><br>";
               flush();
            }
         }
      }
   } // fin entrée invalide
		
} // fin while


// fermeture de tous les fichiers
fclose ($file_sortie);
fclose ($handle);
fclose ($gepi_file);

// gestion des classes/niveaux homonymes
foreach($classes as $classe) {
   if (in_array($classe, $niveaux)) {
      if (!in_array($classe.'1', $niveaux) and (!in_array($classe.'1', $classes))) {
         $renommage[$classe] = $classe.'1';
      }else{
         $renommage[$classe] = $classe.'A';
      }
      print "<br><font color=green>La classe <b>$classe</b> sera renommée en <b>".$renommage[$classe]."</b></font>";
   }
}
session_register("renommage");

echo "<h3>".$valide." élèves ont été extraits</h3>";

// remet l'ancienne valeur !
ini_set("max_execution_time",$old);

?>
