<?

// on se donne + de temps que d'habitude
$old=ini_set("max_execution_time",1000);

/*===========================================================================================

                       extraire les données d'un fichier CSV

===========================================================================================*/

include_once "./inc/constantes.php";

// nombre minimum de champs pour l'extraction
$min=5;
// nombre d'entrées valides
$valide=0;

// fichier de sortie
$file_out=$f_prof;
if (!$file_sortie = fopen ($file_out, "w+")) {
   echo "Impossible d'ouvrir le fichier de sortie $file_out";
   exit;
}
// fichier uploadé
$row = 1;
`/usr/share/ead/convert.py $professeurs`;
if (!$handle = fopen("$professeurs", "r")) {
   echo " impossible d'ouvrir le fichier professeur $professeurs\n" ;
   exit;
}
while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) {
   if ($num = count($data) < $min) {
       echo "ligne ".$data[0]." invalide<br>\n";
   }else{
   
   // définition du fichier :
   // 0. numéro prof
   // 1. nom
   // 2. prénom
   // 3. sexe
   // 4. date de naissance
   // (5) login forcé
   // (6) mot de passe forcé
   
   // numéro prof
   if ( ! ($record["NUMEN"]=trim($data[0])) ) {
      $record["NUMEN"] = 'text';
   }
   // nom du professeur
   $record["AINOMU"] = replace_car(ereg_replace('[ ]+'," ",$data[1])) ;
   $record["AINOMU"] = strtoupper(trim($record["AINOMU"])) ;
   // prénom du professeur
   $record["AIPREN"] = replace_car(ereg_replace('[ ]+'," ",$data[2])) ;
   $record["AIPREN"] = trim($record["AIPREN"]) ;
   // sexe
   $record["AISEXE"] = ereg_replace('[ ]+',"",$data[3]) ;
   if ($record["AISEXE"]) {
      // pour l'annuaire ldap la civilité doit etre numerique par consequent on remplace
      // les lettre par le chiffres correspondant 
      $record["AISEXE"] = ereg_replace("M","1",$record["AISEXE"]) ;
      $record["AISEXE"] = ereg_replace("F","2",$record["AISEXE"]) ;
   } else $record["AISEXE"] = "1";

   // date de naissance 
   $record["AINADD"] = ereg_replace('[ ]+',"",$data[4]);
   $record["AINADD"] = ereg_replace('/',"",$record["AINADD"]);
   $record["AINADD"] = reverse_date2($record["AINADD"]);
   // prof princ non pris en compte
   $div = "";
   
   /* champs facultatifs */
   $record["LOGIN"] = ereg_replace('[ ]+',"",$data[5]) ;
   $record["MDP"] = ereg_replace('[ ]+',"",$data[6]) ;
 
   // ecriture des données dans un fichier plat
   if ($record["AINOMU"]!="")
   {
        $buffer = "$record[AINOMU]:$record[AIPREN]:$record[AISEXE]:$record[NUMEN]:$div:$record[AINADD]:".
	          "$matieres:$equipes:$disc:$record[LOGIN]:$record[MDP]\n" ;
        fwrite ($file_sortie, $buffer);
        $valide++;
        if (fmod($valide,100)==0) {
           if ($valide!=0) {
              print "<font size=-1>$valide professeurs lus</font><br>";
              flush();
           } 
        }
 }
   } // fin entrée invalide
		
} // fin while


// fermeture de tous les fichiers
fclose ($file_sortie);
fclose ($handle);

echo "<h3>".$valide." professeurs ont été extraits</h3>";

// remet l'ancienne valeur !
ini_set("max_execution_time",$old);

?>
